<?php

/**
 * Created by PhpStorm.
 * User: root
 * Date: 11/17/16
 * Time: 2:20 PM
 */
class Products extends Controller
{

    public function Products()
    {

        parent::Controller();


    }


    public function getSapOrders($data = null)
    {
        $data = json_decode($data, true);


        $sql = "
                SELECT `order_id`, `order_visitId`, `order_createDate`, `order_completeDate`, `order_date`, `order_status`, `order_whs`, `order_ddate`, `order_value`, `order_custRef`, `order_comment`, `order_error`, `order_tax`, `order_gross`, `order_expense`, `order_cancelled`, `order_freight`, `order_credit`, `order_sapId`, `order_from`, `order_clientAcct`
                FROM `tbl_orders`
                JOIN tbl_distributors ON order_clientAcct = distributor_accountName
                JOIN tbl_users ON salesEmpNo = user_sapId
                WHERE order_from = 'SAP'
                AND user_id='" . $data['user_id'] . "' AND order_id >'" . $data['last_order'] . "'
               ";

        if ($res = $this->db->query($sql)) {

            //for ($rows = array(); $row = $res->fetch_assoc(); $rows[] = $row) ;
 
          //modified to decode the order status ...
          $rows = array();
          while($row=$res->fetch_assoc()):
            $status = $row['order_status'];
            if($row['order_cancelled'])
            {
              $row['order_status'] = "Cancelled";
            }
            else
            {
              if($status == 0)
                $row['order_status'] = "Recieved";
              elseif($status == -2)
                $row['order_status'] = "Routed for Credit Check";
              elseif($status == 1)
              {
                $row['order_status'] = ($row['order_sapId'] == 0) ?
                     ($row['order_error'])? substr($row['order_error'],0,100):"Waiting For SAP":
                     "SAP Order NO - ".$row['order_sapId'];
              }
              elseif($status == -3)
                $row['order_status'] = "Failed-SAP Insert";
              elseif($status == -1)
                $row['order_status'] = $row['order_error'];
            }
            
            $rows[] = $row;
          endwhile;
           
            return json_encode(array("status" => true, "data" => $rows));

        }

        return json_encode(array("status" => false));

    }

    public function getCsfaOrders($data = null)
    {


        $data = json_decode($data, true);


        $sql = "
                SELECT `order_id`, `order_visitId`, `order_createDate`, `order_completeDate`,order_date , `order_status`, `order_whs`, `order_ddate`, `order_value`, `order_custRef`, `order_comment`, `order_error`, `order_tax`, `order_gross`, `order_expense`, `order_cancelled`, `order_freight`, `order_credit`, `order_sapId`, `order_from`, `order_clientAcct`
                FROM tbl_orders JOIN tbl_visits
                ON order_visitId = visit_id AND visit_userId =" . $data['user_id'] . " AND order_id >" . $data['last_order'] . "
               
                ";

        if ($res = $this->db->query($sql)) {

            //for ($rows = array(); $row = $res->fetch_assoc(); $rows[] = $row) ;

          
          //modified to decode the order status ...
          $rows = array();
          while($row=$res->fetch_assoc()):
            $status = $row['order_status'];
            if($row['order_cancelled'])
            {
              $row['order_status'] = "Cancelled";
            }
            else
            {
              if($status == 0)
                $row['order_status'] = "Recieved";
              elseif($status == -2)
                $row['order_status'] = "Routed for Credit Check";
              elseif($status == 1)
              {
                $row['order_status'] = ($row['order_sapId'] == 0) ?
                     ($row['order_error'])? substr($row['order_error'],0,100):"Waiting For SAP":
                     "SAP Order NO - ".$row['order_sapId'];
              }
              elseif($status == -3)
                $row['order_status'] = "Failed-SAP Insert";
              elseif($status == -1)
                $row['order_status'] = $row['order_error'];
            }
            
            $rows[] = $row;
            endwhile;
          
          
            return json_encode(array("status" => true, "data" => $rows));

        }

        return json_encode(array("status" => false));

    }


    public function getOrderItems($data = null)
    {

        $data = json_decode($data, true);

        return json_encode(array(
            "status" => true,
            "data" => $data['type']=="sap"
                ?
                $this->getSapOrderDetails($data['sap_id'],$data['order_id'])
                :
                $this->getCsfaOrderDetails($data['order_id']))
        );
    }

  private  function getSapOrderDetails($sapId, $oid)
    {
        $conn = mssql_connect('192.168.21.95', 'so', 'Csfa@14');
        //Check only for those that have had the status updated by SAP i.e. sap order id != null
        $sql = "select OrderDetailsID,OrderDetails_SKUID, OrderDetails_Qty from OrderDetailsView where OrderDetailsID = $sapId";
      
      
        $query = mssql_query($sql);
      //var_dump($query);
        if($query === FALSE)
        {
            echo "Error in query prep or exec.\n";
            die( print_r(mssql_get_last_message(),true));
        }
        $sap = array();
       
        while($row = mssql_fetch_array($query)) {
            $sap[] = array(
                'od_skuQty' => $row['OrderDetails_Qty'],
                'od_skuId' => $row['OrderDetails_SKUID'],
                'od_id' => $row['OrderDetailsID'],
                'od_orderid' => $oid,
                'item_majorclass' => 'PREM',
                'item_code' => $row['OrderDetails_SKUID'],
                'item_name' => '',
                'od_QtyNew' => '-1'
            );

        }

        return $sap;
    }

    private  function getCsfaOrderDetails($orderId)
    {

        $sql = "SELECT * 
                FROM tbl_orderdetails 
                WHERE od_orderid ='".$orderId."'";

        $rows=array();

        if ($res = $this->db->query($sql)) {

            for ($rows = array(); $row = $res->fetch_assoc(); $rows[] = $row);



        }

        return $rows;
    }


    public function getAllItems()
    {

        //   $data = json_decode($data, true);


        $sql = "SELECT * 
                FROM tbl_items ";

        if ($res = $this->db->query($sql)) {

            for ($rows = array(); $row = $res->fetch_assoc(); $rows[] = $row) ;


            return json_encode(array("status" => true, "data" => $rows));

        }

        return json_encode(array("status" => false));

    }


}